
__doc__ = """RandomItem."""

__version__ = '0.0.1'


import string, random
from Globals import HTMLFile, MessageDialog, Persistent

import OFS
import Acquisition
import AccessControl.Role


manage_addRiForm = HTMLFile('addRandomItems', globals()) 


def manage_addRi(self, id, title='', REQUEST=None):
   """Add a RandomItems to a folder."""
   self._setObject(id, RandomItems(id, title))
   if REQUEST is not None:
      return self.manage_main(self, REQUEST)


class RandomItems(OFS.ObjectManager.ObjectManager, OFS.SimpleItem.Item, AccessControl.Role.RoleManager):
   """RandomItems object. Stores a list of items."""

   meta_type = 'RandomItems'

   manage_options = ( # what management options are there?
      {'label': 'Edit',    'action': 'manage_main'},
      {'label': 'View',    'action': ''}, # defaults to index_html
      {'label': 'Security',   'action': 'manage_access'},
   ) 

   __ac_permissions__=( # what permissions make sense for us? 
      ('View management screens', ('manage_tabs','manage_main')),
      ('Change permissions',      ('manage_access',)          ),
      ('Change RandomItems' ,     ('manage_edit',)            ),
      ('View',                    ('index_html',)             ),
      ('Add RandomItem',          ('manage_addRItem',)        ),
      )

   meta_types=(
      {'name': 'RandomItem', 'action' : 'manage_addRandomItemForm'},
   )

   def __init__(self, id, title=''):
      """initialise a new instance"""
      self.id = id
      self.title = title


   index_html = HTMLFile('viewRandomItems', globals()) # View Interface

   manage_main = HTMLFile('editRandomItems', globals()) # Management Interface

   manage_addRandomItemForm = HTMLFile('addRandomItem', globals()) 


   def manage_edit(self, title, REQUEST=None): 
      """edit it"""
      self.title = title

      if REQUEST is not None:
         return MessageDialog(
            title = 'Edited',
            message = "Properties for %s changed." % self.id,
            action = './manage_main',
            )


   def __call__(self):
      return random.choice(self.objectValues(['RandomItem']))


   def manage_addRItem(self, id, title='', text='', REQUEST=None):
      """Add a RandomItem to the list."""
      self._setObject(id, RandomItem(id, title, text))
      if REQUEST is not None:
         return self.manage_main(self, REQUEST)


class RandomItem(OFS.SimpleItem.Item, Persistent, Acquisition.Implicit, AccessControl.Role.RoleManager): 
   """RandomItem object. Stores a line of text."""

   meta_type = 'RandomItem'

   manage_options = ( # what management options are there?
      {'label': 'Edit',    'action': 'manage_main'},
      {'label': 'View',    'action': ''}, # defaults to index_html
      {'label': 'Security',   'action': 'manage_access'},
   ) 

   __ac_permissions__=( # what permissions make sense for us? 
      ('View management screens', ('manage_tabs','manage_main')),
      ('Change permissions',      ('manage_access',)          ),
      ('Change RandomItem' ,      ('manage_edit',)            ),
      ('View',                    ('index_html',)             ),
   )

   def __init__(self, id, title='', text=''):
      """initialise a new instance"""
      self.id = id
      self.title = title
      self.text = text


   index_html = HTMLFile('viewRandomItem', globals()) # View Interface

   manage_main = HTMLFile('editRandomItem', globals()) # Management Interface


   def manage_edit(self, title, text, REQUEST=None): 
      """edit it"""
      self.title = title
      self.text = text

      if REQUEST is not None:
         return MessageDialog(
            title = 'Edited',
            message = "Properties for %s changed." % self.id,
            action = './manage_main',
            )


   def __call__(self):
      return self.text
